#ifndef _PARSEC_MIC_DB_H_
#define _PARSEC_MIC_DB_H_

#include <pwd.h>
#include <sys/stat.h>

#include <parsec/parsec_mic.h>

#ifdef __cplusplus
extern "C" {
#endif

/***************************************************
 *           WORKING WITH CONFIG FILES             *
 ***************************************************/

#define SECURITY "security"

    struct mic_user {
		char *name;
        mic_t il;
	};

/* mic */
    struct __mic_han_t;
    typedef struct __mic_han_t *mic_han_t;

    extern struct mic_user *parse_mic(const char *buff,
        struct mic_user *mu);
    extern char *compose_mic(const struct mic_user *mu);

	// thread-safe base API
    extern mic_han_t openmicdb_r(void);
    extern int closemicdb_r(mic_han_t han);

    extern void freemicent_r(struct mic_user *res);
    extern int setmicent_r(mic_han_t han);
    extern int endmicent_r(mic_han_t han);
    extern struct mic_user *getmicent_r(mic_han_t han);
    extern struct mic_user *getmicnam_r(mic_han_t han,
		const char *name);
    extern struct mic_user *getmicuid_r(mic_han_t han, uid_t uid);
    extern int rmmicnam_r(mic_han_t han, const char *name);
    extern int putmicent_r(mic_han_t han, const struct mic_user *mu);

    extern struct mic_user *fgetmicent_r(FILE *fd);
    extern int fputmicent_r(FILE *fd, const struct mic_user *mu);

	// common old API
    extern int setmicent(void);
    extern void endmicent(void);
    extern struct mic_user *getmicent(void);
    extern struct mic_user *getmicnam(const char *name);
    extern struct mic_user *getmicuid(uid_t uid);
    extern int putmicent(const struct mic_user *mu);
    extern struct mic_user *fgetmicent(FILE * f);
    extern void fputmicent(FILE * f, const struct mic_user *mu);
    extern int rmmicnam(const char *name);

#ifdef __cplusplus
}
#endif
#endif	/* _PARSEC_MIC_DB_H_ */
